## RiskyMod
A full-game overhaul that aims to bring it closer to RoR1's balance. My main priority is multiplayer, but the mod is balanced in solo as well.

I highly recommed installing https://thunderstore.io/package/Moffein/EliteReworks/ to go with this.

Full change list can be found here. https://docs.google.com/document/d/1Igxdur0M33fdkcDLYgDEbLE0M4-89gSTorxgdn-oyKs/

This mod merges in fixes and tweaks from a bunch of other mods. If you have those mods installed, these fixes/changes will disable and the original mod will take priority (Except for Bandit Grace Period).

Feel free to take features of this mod and release them as standalone as long as you link the original GitHub repo in the README.

## Main Features

- Removed proc chains.
- Oneshot Protection now actually works.
	- Oneshot = Going from >90% HP to 0% HP in under 0.5s
	- Once triggered, you have to be out of danger (no damage for 7s) before it can be retriggered.
- Shields gate against HP damage like the Guardian's Heart in RoR1.
	- Transcendence/Perfected Affix disable Oneshot Protection due to having shieldgating built-in.
- Big balance pass over nearly all the items.
	- Bad items like Squid Polyps and Warbanners have gotten substantial buffs.
	- Strong damage items like AtGs and Elemental Bands now have lowered damage.
	- Most forms of range scaling have been removed.
- Big balance pass over all the Survivors
	- Less useless skill options, default Commando is good now!
- Drones performance now remains the same on all stages.

## Other Changes

- Combat Shrines give less money, but drop items for the team on completion.
- Teleporter radius expands once the boss is dead.
- Tweaked Commencement
	- Only 2 pillars are required to activate the jump pads.
	- Pillars drop items for the team on completion, and you can complete as many as you want.

## Installation
Place RiskyMod.dll **AND** the **language folder** in /Risk of Rain 2/BepInEx/plugins/RiskyMod

## Planned Changes (Not implemented yet)

*Mostly done with everything I've wanted to do with the mod. Plan going forward is to iron out the existing balance and do a bit of spawn pool tweaking. I don't like the state that Pennies/Watch/Elixir are in, and Corpsebloom/Desk Plant are still bad, but they probably won't get changed. I personally just blacklist them when playing.*

- Make Google Doc more readable/pretty.
	- Split up into multiple separate docs?
- Empathy Cores ignores ally limit?
- Defense Nucleus ignores ally limit?
	- Change scaling to +damage instead of +max allies.
- Run Scaling
	- Adjust gold scaling
- Void Fiend
	- Look at Utility
- Enemies
	- Enemy Pools
		- Make Wisps/Pests/Jellyfish never overlap on any stage?
		- Remove Alpha Constructs from all stages except Sulfur Pools
			- Alpha Constructs on Distant Roost postloop, instead of Titanic Plains?
		- Remove Xi Constructs from every map except Sulfur Pools (and maybe Sky Meadow?)
		- Sundered Grove
			- Remove Dunestrider
			- Remove Lemurians
			- Add Grovetender
			- Add Vultures
			- Remove either Larva or Jellyfish?
		- Should Larva be spawning on Aqueduct?
		- Worms on Aqueduct when looping.
		- Overloading Worms on any map that Magma Worms can spawn on.
		- Sky Meadow
			- Remove Xi Constructs?
			- Remove Alpha Consructs
			- Add Imps
			- Bring back Worms?
			- Add Lunar Golems?
	- Make Mushrums less cancer.
	
## Credits

Drone Targeting fix - ZetTweaks

Squid Polyp distraction - DestroyedClone

Language Support - Anreol

Skill Icons - KoobyKarasu

Acrid Hitbox Tweaks - TheTimesweeper

Buff Icons - SOM

## Changelog

`0.7.7`

- Fixed incompatibility with NetworkedTimedBuffs.
- Bandit
	- Desperado: Disabled changes by default.
			- Now listed as "Desperado Persist" in the config.
			- Desperado Persist damage boost can now be configured.
				- Default multiplier reduced from +0.015/stack -> +0.01/stack
			
		*This was too easy to steamroll with, with Desperado stacks permanently boosting your Revolver damage so that you could gain even more Desperado stacks more easily. I'm not a fan of the Vanilla behavior. Originally had some alternative planned but it seems like it won't work due to technical reasons for the time being.*

`0.7.6`

- Fixed a ProjectileCatalog error that was introduced in the 0.7.0 update.
	- This caused the mod's custom projectiles to break in multiplayer, along with potentially causing a whole host of other issues and incompatibilities.
		- Artificer and Acrid's MP issues should be fixed now.

`0.7.5`

- Gold Scaling
	- Changed how decimal gold values are handled so that RNG isn't involved.
		- The decimal gets saved to a bank. Once the bank has stored $1, it gets added to the next monster that spawns.
		- If the monster is worth <$1, just set their cost to $1 and ignore the bank.
		
	- Gold - Scale to Modded Combat Director Credit Multiplier (Renamed in config)
		- Now divides by the full modded combat director multiplier instead of applying sqrt first.
		
	- Gold - Scale to Combat Director Credit Rate (Renamed in config) is now disabled by default and marked as Experimental.
	
		*This option needs more testing and balancing before it's ready to be enabled by default since it ends up making loop money gain too low (it ends up being lower than Stage 1 proportional to chest costs). The end goal with this option is to make looping money gain/farming similar to the first loop.*

- Captain
	- Supply Beacon loadout description slightly changed.
- REX
	- Fixed Directive: INJECT description listing the chance as 20% instead of 15%

`0.7.4`

- Gold Scaling
	- Improved how decimal gold values are handled.
		- Since Gold only accepts integer (non-decimal) values, it would get rounded to the nearest int (with a min gold reward of 1) after all the ratios are applied, which could cause too little gold to drop from Beetles and other trash mobs.
		- New behavior takes the floor of the final gold value, then uses random chance to decide if it should add an extra +1 gold based on the leftover decimal.
		
		*This will mainly only matter earlygame when that $1 difference can mean a lot.*
		
	- Gold - Scale to Combat Director Credits
		- Reduced coefficient from 1.4 -> 1.3
			- New formula is 1.3/(1 + 0.3 x difficultyCoefficient)
		
	*Still trying to fine-tune the new gold scaling behavior. Gold earn rate was feeling too slow while looping, so I reduced how much it gets decreased. Let me know if any more changes are needed, or if things feel fine. Every bit of feedback helps, since this is a pretty major change to the gameplay loop in general.*

`0.7.3`

- Fixed Scepter compatibility.
- Run Scaling
	- Gold Scaling
		- Gold scaling now divides gold gain by sqrt(Combat Director Multiplier)
		
		*Let me know if this has too much earlygame impact.*
		
	- Combat Director Multiplier increased from 1.2 -> 1.4
		**- You will need to manually change this setting if you're updating from a previous version.**
		
		*First loop was feeling too sleepy. After analyzing the difficulty graphs of Linear Scaling vs Vanilla Scaling, it turns out most of the difficulty from the old pre-0.7.0 scaling actually came from the enemy spawnrates, rather than the scaling values. 1.4 is slightly less than the halfway point between the minimum Director multiplier (1.2) and the maximum multiplier (1.7) that Linear Scaling used to use. Played some Commando/Railgunner runs and the spawnrates didn't seem too unreasonable, but let me know how this feels!*

`0.7.2`

- Artificer
	- Fixed Ion Surge not being in the Utility slot by default.
	
TODO: Experiment with Desperado changes.

`0.7.1`

- Items
	- Polylute
		- Increased proc coefficient from 0 -> 0.1 to match Ukuleles
		
		*Need to see how this plays.*
		
- Captain
	- Hack Beacon now uses the correct model. (Thanks DestroyedClone!)
	- Added per-beacon config.
		- Enable Changes and Enable Cooldown for each one.

`0.7.0`

*Releasing this earlier than I was planning to due to the Vanilla update. Captain/Arti/Acrid changes need more balance testing. Haven't had much time to test things so lemme know if things are broken.*

- Config
	- Split the config into multiple files to improve readability.
		- This will reset ALL config options.
		- I recommend deleting your old config file.
	- Luck Cap is now listed under Legendary Items as 57 Leaf Clover Changes since it's dependent on ItemsCore. (still disabled by default)
	- Moved a lot of config options around.
	
	*Hoping this is the last major config restructuring that will be needed.*
	
- Run Scaling
	- Scaling
		- New Modded Scaling
			- Same as Vanilla but with a few tweaks to multiplayer scaling.
				- Reduced per-player exponential from playerCount ^ 0.2 -> playerCount ^ 0.1
			
			*Vanilla Scaling is needed because the game can't keep up while looping on Linear Scaling. At the same time Vanilla Scaling works pretty poorly in large lobbies due to how the difficulty scales. Planning to adjust this number til an appropriate balance is found.*
			
		- Linear Scaling
			- Disabled Linear Scaling by default.
			- Combat Director spawnrate changes are its own config option now.
		
			*Idea was that no proc chains would make exponentially scaling enemies not necessary, but it turns out that wasn't the case. In retrospect, even RoR1 ended up behaving this same way, with Starstorm's Ethreal portals being necessary for loop difficulty.*
			
	- Loop Boss Armor increased from 20 -> 40
		- Now doesn't affect enemies with Adaptive Armor (Mithrix)
	
	- Combat Director credit multiplier increased from 1x -> 1.2x
		- This is different from the changes that used to be associated with Linear Scaling, where the spawnrate would scale from 1.2x up to 1.7x over 5 stages. Those changes are gone now.
		
	- Money
		- Monster death rewards are now scaled to the price of chests at the start of the stage.
		- Monster death rewards are now multiplied by 1.4/(1 + 0.4 x difficultyCoefficient) to match the Combat Director's increasing Director Credits.
		
		*This makes it so that farming is still relevant on later stages. I'm happy with how this feels in singleplayer, but I don't know how it scales in multiplayer.*
		
- Allies
	- Increased superattack resistance from 50% -> 66%
	- Fixed Squid Turrets unintentionally getting shields.
	- Grandparents on the Player team (from Happiest Mask or Chirr) no longer teamkill other Players.
	- Spare Drone Parts
		- Fixed description incorrectly listing it as doing 70% damage.
		- Increased Chaingun damage from 6x50% -> 6x60%
	- TC280
		- Reduced base cost from 350 -> 300
		- Can now be repaired after being destroyed. (Based on ZetTweaks)
			- Code doesn't run if ZetTweaks is installed.
			
	*Todo: see if shields should be re-added now that exponential scaling is enabled by default. Noticing most drones are underpeforming in general when it comes to damage.*
	
- AI Blacklist
	- Added Frost Relic
	
- Interactables
	- Combat Shrine/Mountain Shrine/Void Seed playercount-scaled credit cost removed due to the latest update breaking it.
	- Void Seed
		- Now limited to 1 per stage.
		
		*Multiple Void Seeds spam tons of enemies and all end up sharing the same objective tracker, requiring you to go on a scavenger hunt around the map to find where all the enemies are. A massive timesink without much reward.*
		
- Void Fields
	- Radius increased from 20m -> 30m (Vanilla is 15m)
	- Cell charge duration reduced from 60s -> 40s
	
	*Void Fields is quite possibly the most unfun experience the game has to offer, with its endless waiting and claustrophobic holdout size. New charge duration lowers the total charging time from 10m -> 6m 40s (plus travel time). If you use VoidQoL, I recommend adjusting the charge-on-kill value to accommodate this.*
		
- Moon
	- Holdout size increased from 26m -> 30m  (Vanilla is 20m)
	- Pillar of Mass charge duration reduced from 60s -> 45s
	- Pillar of Soul charge duration reduced from 30s -> 20s
	
- Void Locus
	- Holdout size increased from 26m -> 30m  (Vanilla is 20m)
	- Signals now drop items
		- Same odds as Moon, but with no chance of Pearls.
		- Does not drop Void Items since the stage has spawns for them (and because there's a chance of it spawning something you don't want to pick up)
	- Charge duration reduced from 60s -> 30s
	
	*This stage ususally gets skipped in favor of directly going to Voidling after Mithrix, and it's a boring and unrewarding waitfest if you do decide to do it. Stage already has some item spawns, but I believe that giving the Signals item drops is needed to make them feel rewarding to do. Required Signal count isn't lowered like Moon's Pillar Count due to technical reasons, but I'd do it if I could figure out how.*
	
- Items
	- Lensmaker's Glasses
		- Disabled changes by default.
		
		*Glasses don't seem to be that much of an issue now that it's harder to stack fullcrit due to the item pool being more diluted, and I'm not sure if it actually needed the nerf in the first place. I'll be disabling this by default but leaving it in for people who want it.*
	
	- Crowbar
		- Fixed 0 damage attacks triggering the first-hit condition.
		- Fixed Crowbars causing weak attacks to trigger bands.
		
	- Harvester's Scythe
		- Disabled changes by default.
		
		*The goal behind the rework was to make it so that it doesn't overlap with Leeching Seed, but I don't think I've managed to rework it well in any iteration. The Crit on Kill effect would be good as a standalone modded item focused around that, but trying to work in healing to the effect as well didn't work out. I think flat healing vs damage-scaled healing is a good enough distinction between Scythes and Seeds.*
		
	- Bandolier
		- Now always fully reloads your primary skill.
		- Now works with Power Mode Scrap Launcher when using MUL-T's Scrap Launcher changes.
		
	- Berzerker's Pauldron
		- Attack Speed per stack reduced from 15% -> 12%
		- Movement Speed per stack increased from 10% -> 12%
		
		*This still felt like it was giving too much of a boost with respect to how easy it is to trigger. Attack Speed boost now matches Predatory Instincts. Move Speed boost has been increased to be the same number as the Attack Speed boost to make it easier to remember.*
		
	- Leeching Seed
		- Healing now only scales off of initial proc damage, instead of final damage.
			- This means it no longer heals more off of crits/death mark/focus crystal.
			
		*Idea behind Seeds scaling off of final damage was to give it synergy with damage items, but it ended up not being much of a consideration since those items are items you'll always be taking anyways. Hoping to get this balanced to be around the same level as Vanilla Scythes.*
		
	- Infusion
		- Fixed the buff remaining on the HUD when the item isn't in your inventory.

	- Rose Buckler
		- Bonus armor while sprinting increased from 10 -> 20
		
		*This makes it perform the same as Vanilla while sprinting. 10 armor passive, 20 conditional.*
		
	- Ukulele
		- Removed damage scaling.
		- Increased proc coefficient from 0 -> 0.1 (0.2 is vanilla)
		
		*Was originally opposed to any type of proccing on this item, but after having played with it for a while, it simply doesn't feel that good without it. Going to try setting it lower than Vanilla first.*
		
	- Polylute
		- Reduced hitcount from 3 (+3) -> 3 (+2)
		
		*This makes the scaling similar to other damage items and Ukuleles.*
		
	- Sentient Meathook
		- Removed damage scaling.
		- Increased proc coefficient from 0 -> 0.1 (0.33 is vanilla)
		
		*Same reasoning as Ukulele.*
		
	- H3AD-5T
		- Removed cooldown scaling.
		- Cooldown is now cleansable by Blast Shower. (Credits to SOM for the buff icon!)
		
		*Cooldown Scaling isn't needed anymore since it got changed to scale damage with stacks a few updates ago. Cooldown is cleansable to be consistent with other item cooldown effects.*
		
	- Ben's Raincoat
		- Removed changes since the new Vanilla effect is pretty similar.
		
	- Resonance Disc
		- Increased proc coefficient from 0.5 -> 1.0
		
		*I have never seen a single person chase after this item at any point in time. Probably fine to just leave it with its Vanilla stats. All the config option does now is enable it to charge up from assists.*
		
	- Pluripotent Larva
		- Removed blacklist fix since it's Vanilla now.
		
- Survivors
	- Anti flying force max mass reduced from 1000kg -> 400kg (This is only used for reworked MUL-T M2 + Acrid Shifts)
		- No longer can gib the AWU (1000kg)
		- Heaviest thing it can knock around are Greater Wisps/Lunar Wisps (300kg)
		
		*Turns out that this could still be used to easily gib bosses even with the previous changes due to the checks that prevent it not working in multiplayer.*
		
- Commando
	- Frag Grenade
		- Self damage reduced from 60% -> 33%
		
- Artificer

	*With these changes, new DPS is somewhat comparable to REX, which I'm fine with since REX is easier than Arti.*

	- Primaries
		- Flame Bolt
			- Damage increased from 300% -> 390%
			
			*Probably the hardest M1 to actually aim with, and the only ranged M1 that actually has a problem with killing Wisps (aside from Scrap Launcher).*
			
		- Plasma Bolt
			- Damage increased from 300% -> 390%
			
			*The effect is boring, but it can at least 1shot Wisps comfortably now. Might end up being technically better than Flame Bolt due to the AoE being more valuable than ignite lategame, but I think they're close enough.*
				
	- Utilities
		- Snapfreeze (Rework)
			- Summons an Ice Wall if aiming at a valid position on the ground. (Same as Vanilla)
			- Now always creates a 6m Freezing blast that deals 100% damage where your crosshair is aiming.
				- This can be aimed at airborne enemies.
				- Applies self-knockback in a 14m radius around the blast.
			
			*Goal with this rework is to fix Snapfreeze being useless against flying enemies and to solve the longstanding issue of Artificer having no mobility in her base kit.*
			
		- Ion Surge
			- Moved to Utility slot.
			- Increased cooldown from 8s -> 12s to match Snapfreeze
				
		- Blaze Storm (New Fire Utility)
			- TODO: Add unique icon
			- 12s cooldown.
			- Hold Shift to aim, release to create an Igniting fire tornado where your crosshair is aiming.
				- Deals 10x140% damage in an 8m AoE over 3.3s
				- Applies self-knockback in a 14m radius around the blast.
				
			*Was originally going to rework Ion Surge into a castable skill like Ice Wall, but decided not to, so it has been quickly repurposed into being a new Fire utility. Not sure if this should even be enabled by default since it's such a low effort asset flip.*
			
		- Flamethrower
			- Increased range from 20m -> 25m

- Acrid
	- Passives
		- Virulent
			- No longer affects Epidemic.
			- Duration increased from +40% -> +80%
			
			*Virulent's duration increase wasn't significant enough to be worth taking over Contagion. With the Poison/Blight changes below, Poison remains the same while Blight's new boosted duration goes up from 7s to 10s.*
			
		- Contagion
			- No longer affects Epidemic.
			- Now transfers all of the victim's stacks of Blight.
			- Reduced spread range from 40m -> 30m to match Epidemic
			
			*Being able to spread Epidemic ended up being a bit too much　due to its ability to proc. Shifting the focus of the skill towards letting you keep your Blight stacks going even after killing an enemy.*
	
	- DoTs
		- Poison
			- Base duration reduced from 7s -> 6s
				- Virulent duration is rounded up to 10s
			
		- Blight
			- Base duration increased from 5s -> 6s
				- Virulent duration is rounded up to 10s
	
	- Epidemic
		- Increased damage from 6x100% -> 8x100%
		
		*This is just the same as pre-update Virulent Epidemic.*
		
- Captain
	- Defensive Microbots
		- No longer scales with attack speed.
		- Now scales off how many drones you have.
			- +20% recharge rate per drone (equivalent to +20% attack speed).
			
		*Numbers need fine tuning. Overall a net loss in how high you can scale the recharge rate, which is intended since it's an item that removes the need to dodge a lot of types of projectiles.*
			
	- Vulcan Shotgun
		- Charging is now affected by attack speed.
			- Pump animation still is NOT affected by attack speed.
		- Force is now divided by sqrt(bulletcount/7)
			- Extra pellets will increase the total force, but it'll increase at a slower rate than before.
	- Power Taser
		- Spreads to up to 6 additional targets. (15m range per bounce)
		
	- Diablo Strike
		- Now only receives 50% cooldown from Bandoliers.
		
		*This change is mainly geared towards the Resupply Beacon changes, which allow Captain to have 3 Bandolier uses on-demand. (It recycles Bandolier's restock code due to networking reasons)*
		
	- Orbital Supply Beacon
		- Beacons now regenerate every 60s.
			- Unaffected by Bandoliers.
		- Now affected by Lysate Cell.
			- 1st Cell increases the Left Beacon, 2nd Cell increases the Right Beacon. Each Beacon maxes out at 2 active, and extra stocks will simply give you more chances to replace them.
			
	- Beacon: Shocking
		- Radius increased from 10m -> 15m
		
		*Can't be bothered to think of anything for it. With the increased radius, it can make a decent safe zone around your other beacons I guess.*
		
	- Beacon: Resupply
		- Max uses reduced from 3 -> 2
		- Regains 1 use every 30s.
		
	- Beacon: Hack (Rework)
		- Removed Vanilla effect.
		- Recharges Skills when interacted with.
			- 3 max uses
			- Regains 1 use every 20s
			- Counts as a Bandolier.
				- Restores 50% of Diablo Strike's cooldown.
				- Does not affect Beacons.
		
		*Vanilla version was exclusively used by Captains to grab all the items on the map before anyone else could. Hoping this new effect will lead to some interesting synergies with certain Survivors.*
		
- Bandit
	- Added primary fire select config options (disabled by default).
	- Knife skills no longer interrupt reloading.
	- Hemmorrhage proc coefficient increased from 0 -> 0.3
	
		*Hemmorrhage ended up being underwhelming while looping, especially considering the effort/risk required to apply it in the first place.*
	
- Railgunner
	- Polar Field Device
		- Slowed projectiles now deal 50% less damage.
		
		*Don't really have any clue how to make this skill worthwhile while keeping its effect similar to Vanilla, so here's a small tweak.*
		
- Void Fiend
	- Corrupted Flood
		- Can now be fired while using Corrupted Drown.
	- Corrupted Suppress
		- Reduced duration from 0.5s -> 0.3s